include:
  - local: "templates/ping.yml"
  - local: "templates/a11y.yml"
  - local: "templates/code_quality.yml"
  - local: "templates/npm_junit.yml"
  - local: "templates/secret_detection.yml"
  - local: ".gitlab-ci/docker.yml"

stages:
  - validate
  - test
  - build-and-push

variables:
  BUILD_ID: $CI_COMMIT_SHORT_SHA
  TEST_URL: https://www.google.com
  FABRIC_GITLAB_CI_TEMPLATE_BUCKET_URL: s3://fabric-ci-templates
  FABRIC_GITLAB_CI_TEMPLATE_VERSION: v0.0.1
  # CI_DEBUG_TRACE: "true"

.rules:
  rules:
    - if: &merge-request '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: always
    - if: &main-branch '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: always

syntax check:
  extends: .code-quality
  stage: validate
  needs: []
  allow_failure: true
  rules:
    - if: *merge-request
    - if: *main-branch

secret detection:
  stage: validate
  extends: .secret_detection_default_branch
  rules:
    - if: *main-branch
    - if: *merge-request

format check:
  stage: validate
  image: mvdan/shfmt:v3.3.0-alpine
  before_script:
    - apk update && apk add make
  script:
    - make fmtcheck
  needs: []
  rules:
    - if: *merge-request
    - if: *main-branch

templates sync check:
  image: registry.gitlab.com/fabric2/ci-templates/python:awscli-e578ca86
  stage: validate
  script:
    - make templates
    - apk add git
    - git diff --quiet || (echo Templates are out-of-date. Please update templates by running \`make\` && exit 1)
  needs: []
  rules:
    - if: *merge-request
    - if: *main-branch

test-ping:
  stage: test
  extends: .ping
  needs: []
  variables:
    PING_URL: $TEST_URL
  rules:
    - if: *merge-request
      changes:
        - src/ping.jsonnet

test-a11y:
  stage: test
  extends: .a11y
  needs: []
  variables:
    A11Y_URL: $TEST_URL
  rules:
    - if: *merge-request

test-nexjs-pipeline:
  stage: test
  trigger:
    project: fabric2-public/cicd/react-app-template-test
    branch: main
    strategy: depend
  needs: []
  allow_failure: true
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      changes:
        - templates/pipelines/nextjs.yml
        - src/scripts/artifact/*
        - src/artifacts.jsonnet
